#ifndef opl3emu_timers_hh
#define opl3emu_timers_hh

#include <cmath>

class timer
{
	bool active;
	double timefraction;
public:
	unsigned char value, reset;
	bool hit, irqs;
	
	timer() : timefraction(0) { }
	
	void Reset() { timefraction=0; value=reset=0; hit=false; }

    /* Inlined, because called *very* often */
    inline unsigned Advance(double length, double add)
    {
		add += timefraction;
	#if 0
		unsigned retval = static_cast<unsigned> (add/length);
		timefraction = add-retval*length;
		return retval;
	#else
		timefraction = std::fmod(add, length);
		return static_cast<unsigned> (add/length);
	#endif
    }
    
    void Run(double seconds, double length);
    void Activate();
    void Deactivate();
    void Set(unsigned char nv);
};

class Timers
{
private:	
	timer timer1, timer2;
	
public:
	void Run(double seconds);
	
	const unsigned char ReadStatus() const;
	void WriteTimer1(unsigned char value);
	void WriteTimer2(unsigned char value);
	void WriteReg4(unsigned char value);
};

#endif
